var BITS_IN_A_BYTE = 8;
var KILO = 1024;
var output = Array(12);


// Execute the script on load
window.addEventListener('load',function(ev){
	// add behavior to the reload button
	document.getElementById('reloadfront').addEventListener('click',function(ev){
		window.location.reload();
	}, false);

	// add behavior to the close button
	document.getElementById('closefront').addEventListener('click',function(ev){
		window.close();
	}, false);

	// add behavior to the expand/contract div
	document.getElementById('expandDiv').addEventListener('click',function(ev){
		toggleResults();
	}, false);

	// add behavior to the go/search button
	document.getElementById('searchButton').addEventListener('click',function(ev){
		var amt = document.getElementById('amountField').value;
		var list = document.getElementById('unitList');
		var unit = list.options[list.selectedIndex].value;

		convert(amt,unit)
		
		if (document.getElementById('expand').src.match('images/arrowdown.png'))
			showResults();
	}, false);
	// add a change handler so that the widget shows whatever we input into the widget front
	document.getElementById('amountField').addEventListener('keypress',function(ev){
		if (ev.keyCode == 13){
			var amt = document.getElementById('amountField').value;
			var list = document.getElementById('unitList');
			var unit = list.options[list.selectedIndex].value;

			convert(amt,unit)

			if (document.getElementById('expand').src.match('images/arrowdown.png'))
				showResults(); 
		}
	},false);
},false);


//load preferences
function loadPrefs() {
/*	// if this if the first time running this widget, load defaults
	if (widget.preferenceForKey('notFirstTime')!='true') {  
		widget.setPreferenceForKey('true','notFirstTime');
		loadDefaults();
	}
*/	
window.resizeTo(270,100);
}

//load defaults
function loadDefaults() {

}



function toggleResults() {
  if (document.getElementById('expand').src.match('images/arrowdown.png'))
    showResults();
  else  hideResults();
}


function showResults() {
	window.resizeTo(270,360);

	var an1 = document.getElementById('middle').createAnimation();
	var an2 = document.getElementById('resultsPane').createAnimation();
	var an3 = document.getElementById('results').createAnimation();
	an1.addAnimation('height','30px','290px');
	an1.speed = 20;
	an1.accelerationProfile = an1.sine;

	an2.addAnimation('height','20px','239px');
	an2.speed = 20;
	an2.accelerationProfile = an2.sine;

	an3.addAnimation('height','0px','235px');
	an3.speed = 20;
	an3.accelerationProfile = an3.sine;

	an3.run();
	an2.run();
	an1.run();

	an1.onfinish = function(){
		document.getElementById('expand').src = 'images/arrowup.png';
	}

	document.getElementById('results').style.display='block';
}


function hideResults() {
	var mode = widget.preferenceForKey('mode');

	var an1 = document.getElementById('middle').createAnimation();
	var an2 = document.getElementById('resultsPane').createAnimation();
	var an3 = document.getElementById('results').createAnimation();
	an1.addAnimation('height','290px','30px');
	an1.speed = 20;
	an1.accelerationProfile = an1.sine;

	an2.addAnimation('height','239px','20px');
	an2.speed = 20;
	an2.accelerationProfile = an2.sine;

	an3.addAnimation('height','235px','0px');
	an3.speed = 20;
	an3.accelerationProfile = an3.sine;

	an2.onfinish = function(){
		document.getElementById('expand').src = 'images/arrowdown.png';
	}
	an3.onfinish = function(){
		document.getElementById('results').style.display = 'none';
		window.resizeTo(270,100);
	}
	
	an1.run();
	an2.run();
	an3.run();
}


// convert between all the units
function convert(amt, unit) {
	switch (unit) {
		case 'b':
			output[0] = amt;
			break;
		case 'B':
			output[0] = amt * BITS_IN_A_BYTE;
			break;
		case 'kb':
			output[0] = amt * KILO;
			break;
		case 'kB':
			output[0] = amt * BITS_IN_A_BYTE * KILO;
			break;
		case 'mb':
			output[0] = amt * KILO * KILO ;
			break;
		case 'mB':
			output[0] = amt * KILO * KILO * BITS_IN_A_BYTE;
			break;
		case 'gb':
			output[0] = amt * KILO * KILO * KILO;
			break;
		case 'gB':
			output[0] = amt *KILO * KILO * KILO * BITS_IN_A_BYTE;
			break;
		case 'tb':
			output[0] = amt * KILO * KILO * KILO * KILO;
			break;
		case 'tB':
			output[0] = amt *KILO * KILO * KILO * KILO * BITS_IN_A_BYTE;
			break;
		case 'pb':
			output[0] = amt * KILO * KILO * KILO * KILO * KILO;
			break;
		case 'pB':
			output[0] = amt *KILO * KILO * KILO * KILO * KILO * BITS_IN_A_BYTE;
			break;
		default:
			break;
	}

	output[1] = output[0] / BITS_IN_A_BYTE;
	output[2] = output[0] / KILO,
	output[3] = output[2] / BITS_IN_A_BYTE,
	output[4] = output[2] / KILO,
	output[5] = output[4] / BITS_IN_A_BYTE,
	output[6] = output[4] / KILO,
	output[7] = output[6] / BITS_IN_A_BYTE,
	output[8] = output[6] / KILO,
	output[9] = output[8] / BITS_IN_A_BYTE,
	output[10] = output[8] / KILO,
	output[11] = output[10] / BITS_IN_A_BYTE;
	
	var results = document.getElementById('results');
	results.innerHTML = '<table id="resultTable"><tr><td width="10%">bits: </td><td>'+output[0] + '</td></tr><tr><td width="10%">bytes: </td><td>'+output[1] + '</td></tr><tr><td width="10%">kilobits: </td><td>'+output[2] + '</td></tr><tr><td width="10%">kilobytes: </td><td>'+output[3] + '</td></tr><tr><td width="10%">megabits: </td><td>'+output[4] + '</td></tr><tr><td width="10%">megabytes: </td><td>'+output[5] + '</td></tr><tr><td width="10%">gigabits: </td><td>'+output[6] + '</td></tr><tr><td width="10%">gigabytes: </td><td>'+output[7] + '</td></tr><tr><td width="10%">terabits: </td><td>'+output[8] + '</td></tr><tr><td width="10%">terabytes: </td><td>'+output[9] + '</td></tr><tr><td width="10%">petabits: </td><td>'+output[10] + '</td></tr><tr><td width="10%">petabytes: </td><td>'+output[11] + '</td></tr></table>';
}


/*
    Written by Jonathan Snook, http://www.snook.ca/jonathan
    Add-ons by Robert Nyman, http://www.robertnyman.com
*/
function getElementsByClassName(oElm, strTagName, strClassName) {
    var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
    var arrReturnElements = new Array();
    strClassName = strClassName.replace(/\-/g, "\\-");
    var oRegExp = new RegExp("(^|\\s)" + strClassName + "(\\s|)");
    var oElement;
    for(var i=0; i<arrElements.length; i++) {
      oElement = arrElements[i];      
      if(oRegExp.test(oElement.className))
        arrReturnElements.push(oElement);
    }
    return (arrReturnElements);
}