/*
OPERA Web Applications Sample License Version 1.0
© Copyright 2006 Opera Software ASA. All rights reserved.

OPERA SOFTWARE ASA (“OPERA”) IS WILLING TO PERMIT USE OF THIS SOFTWARE 
BY YOU, ONLY UPON THE CONDITION THAT YOU ACCEPT ALL OF THE TERMS 
CONTAINED IN THIS DOCUMENT. PLEASE READ THE TERMS AND CONDITIONS OF THIS 
AGREEMENT CAREFULLY. IF YOU ARE NOT WILLING TO BE BOUND, YOU ARE NOT 
ALLOWED TO ACCESS THE CONTENTS OF, STUDY OR MAKE USE OF THE SOFTWARE IN 
ANY WAY. 

Terms of Agreement

Subject to the terms and conditions contained herein, Opera grants you a 
personal, non-exclusive license, under Opera’s intellectual property 
rights in this software (the “Software”), to use, reproduce, modify and 
redistribute the Software, with or without modifications, in source 
and/or binary forms; provided that if you redistribute the Software in 
its entirety or with modifications, you must retain this notice and the 
following text and disclaimers in all such redistributions of the 
Software. You must also cause the software files modified to carry 
prominent notices stating that you changed the files and the date of any 
change. 

Except as expressly stated in this document, no other rights or 
licenses, express or implied, are granted by Opera herein, including but 
not limited to any patent rights that may be infringed by your 
derivative works or by other works in which the Software may be 
incorporated. 

 The Software is provided by Opera on an "AS IS" basis. OPERA MAKES NO 
WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED 
WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A 
PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND OPERATION 
ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 
IN NO EVENT SHALL OPERA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, 
MODIFICATION AND/OR DISTRIBUTION OF THE OPERA SOFTWARE, HOWEVER CAUSED 
AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), 
STRICT LIABILITY OR OTHERWISE, EVEN IF OPERA HAS BEEN ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE. 

This Agreement is governed by the laws of Norway. Any and all disputes 
arising out of the rights and obligations in this Agreement shall be 
submitted to ordinary court proceedings. You accept the Oslo City Court 
as legal venue under this Agreement.  
*/
/* DOM */

(
  function()
  {
    this.add=function(name, attributes, text)
    {
      if(name)
      {
        var ele=this.ownerDocument.createElement(name);
        var prop='';
        if (attributes)
        {
          for (prop in attributes) ele[prop]=attributes[prop];
        }
        if(text) ele.appendChild(this.ownerDocument.createTextNode(text));
        this.appendChild(ele);
        return ele;
      }
      else
      {
        this.appendChild(this.ownerDocument.createTextNode(text));
      }
    }
    this.addClass=function(name)
    {
      this.className=(this.className?this.className+' ':'')+name;
    }
  }
).apply(Element.prototype);

/* cookies */

var setCookie=function(name, value, time) 
{
  if(window['widget'])
  {
    widget.setPreferenceForKey(encodeURIComponent(value), name)
  }
  else
  {
    if(!time) time=360*24*60*60*1000;
    document.cookie = name+"="+encodeURIComponent(value)+
      "; expires="+(new Date(new Date().getTime()+time)).toGMTString()+"; path=/";
  }
}

var getCookie=function(name) 
{
  if(window['widget'])
  {
    return decodeURIComponent(widget.preferenceForKey(name))||null;
  }
  else
  {
    if( new RegExp(name+'\=([^;]*);','').test(document.cookie+';') ) return decodeURIComponent(RegExp.$1);
    return null;
  }
}

var clearCookie=function(name) 
{
  if(window['widget'])
  {
    widget.setPreferenceForKey('', name)
  }
  else
  {
    setCookie(name, '', -1000);
  }
}

var getLocalizedString=function(key)
{
  return localizedStrings[key] || key;
}

