/*
 Copyright 2006 Opera Software ASA. All rights reserved.

*/

function $(id) { return document.getElementById(id);}
function log(str) {opera.postError(str);}

var g_config = {
  isArchos : (navigator.appVersion && navigator.appVersion.match(/ARCHOS/))
};

var CConvertorModel = function() 
{
	var _self = this;
	
	function parseComma(value)
	{
		value = value.replace(",", ".");
		return value;
	}   
	
	function setDecimalSpaces(value)
	{
		if(!value) 
		{
			value = "Incorrect input";
		} 
		else 
		{
			var eValue = 0;
			while(value > 1000000000) 
			{
				value /= 10;
				eValue++;
			}
			value *= 100;
			value = Math.round(value);
			value /= 100;
			if(eValue>0) value = value + ' E' + eValue;
		}
		return value;
	}
  
	
	this.AreaType = 
	[
		[0, "Square kilometres (km)", 1.00, 2],
		[1, "Square metres (m)", 1000000.00],
		[2, "Hectares (ha)", 100.00],
		[3, "Acres", 247.105381],
		[4, "Square miles (sq mi)", 0.386102159, 1],
		[5, "Square yards (sq yd)", 1195990.05],
		[6, "Square feet (sq ft)", 10763910.4]
	];
	
	this.Area = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.AreaType[from][2]) * _self.AreaType[to][2]);
	}
	
	this.TemperatureType =
	[
		[0, "Celcius (C)", 0, 2],
		[1, "Fahrenheit (F)", 1, 1],
		[2, "Kelvin (K)", 2]
	];
	
	this.Temperature = function(from, to, value)
	{
		var output = 0;		
		value = parseComma(value);
		
		switch(from){
			
			case 0:
				switch(to){
					case 0:
						output = value;
					break;
					case 1:
						output = (Math.round(((212-32)/100 * parseFloat(value) + 32)*100))/100;
					break;
					case 2:
						output = parseFloat(value) + 273;
					break;
				}
			break;
			case 1:
				switch(to){
					case 0:
						output = (Math.round((100/(212-32) * (parseFloat(value) - 32))*100))/100;
					break;
					case 1:
						output = value;
					break;
					case 2:
						output = (Math.round((100/(212-32) * (parseFloat(value) - 32))*100))/100 + 273;
					break;
				}
			break;
			case 2:
				switch(to){
					case 0:
						output = (Math.round(parseFloat(value) - 273));
					break;
					case 1:
						output = (Math.round(((212-32)/100 *(parseFloat(value) - 273) + 32)*100))/100;
					break;
					case 2:
						output = value;
					break;
				}
			break;
		}
		return setDecimalSpaces(output);
	}
	
	this.TimeType  =
	[
		[0, "Days", 1],
		[1, "Weeks", 0.14285714285714285714285714285714],
		[2, "Years", 0.002739726027397260273972602739726],
		[3, "Hours", 24, 1],
		[4, "Minutes", 1440, 2],
		[5, "Seconds", 86400],
		[6, "Miliseconds", 86400000]
	]
	
	this.Time = function(from, to, value)
	{
		return Math.round((parseFloat(value)/_self.TimeType[from][2]) * _self.TimeType[to][2]);	
	}
	
	this.DistanceType = 
	[
		[0, "Kilometres (km)", 1],
		[1, "Metres (m)", 1000, 2],
		[2, "Miles (mi)", 0.621371192],
		[3, "Nautical miles (nmi)", 0.539956803455723],
		[4, "Yards (yd)", 1093.6133],
		[5, "Feet (ft)", 3280.8399, 1],
		[6, "Inches (in)", 39370.0787]
	];
		
	this.Distance = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.DistanceType[from][2]) * _self.DistanceType[to][2]);	
	}
	
	this.WeightType = 
	[
		[0, "Kilograms (kg)", 1],
		[1, "Grams (g)", 1000, 2],
		[2, "Pounds (lb)", 2.20462262],
		[3, "Ounces (oz)", 35.2739619, 1],
		[4, "Short tons (S/T)", 0.00110231131],
		[5, "Imperial tons (L/T)", 0.000984206528],
		[6, "Stones (st)", 0.157473044]
	];	
	
	this.Weight = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.WeightType[from][2]) * _self.WeightType[to][2]);	
	}

	this.SpeedType = 
	[
		[0, "Kilometres per hour (km/h)", 1, 2],
		[1, "Metre per minute", 16.6666667],
		[2, "Knots (kn)", 0.539956803],
		[3, "Miles per hour (mph)", 0.621371192, 1],
		[4, "Feet per minute", 54.6806649]
	];
	
	this.Speed = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.SpeedType[from][2]) * _self.SpeedType[to][2]);	
	}
	
	this.PressureType =
	[
		[0, "Pound per square inch (psi)", 1],
		[1, "Pascal (Pa)",  6894.75729, 2],		
		[2, "Atmospheres (atm)" , 0.0680459639],
		[3, "Bars (ba)", 0.0689475729],
		[4, "Centimetres of mercury (cmHg)", 5.17142997],
		[5, "Pound-force per sq inch (psi)", 1, 1]	
	];
	
	this.Pressure = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.PressureType[from][2]) * _self.PressureType[to][2]);	
	}
	
	this.PowerType = 
	[
		[0, "Horsepower (hp)", 1],
		[1, "BTUs per minute (BTU / min)", 42.416666, 2],
		[2, "Kilowatts (kW)", 0.745699872, 1],
		[3, "Watts (W)", 745.699872]	
	]
	
	this.Power = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.PowerType[from][2]) * _self.PowerType[to][2]);	
	}
	
	this.VolumeType = 
	[
		[0, "Litre (L)", 1, 2],
		[1, "Mililitre (ml)", 1000],
		[2, "Cubic metre (m)", 0.001],
		[3, "Cubic feet (cu ft)", 0.0353146667],
		[4, "Imperial gallon (gal Imp)", 0.219969157],
		[5, "Gallon (gal)", 0.264172051, 1]
	]
	
	this.Volume = function(from, to, value)
	{
		return setDecimalSpaces((parseFloat(value)/_self.VolumeType[from][2]) * _self.VolumeType[to][2]);	
	}
	
	this.NumbersType =	
	[
		[0, "Decimal", 10, 1],
		[1, "Binary", 2, 2],
		[2, "Octal", 8],
		[3, "Hexadecimal", 16]
	]
	
	this.Numbers = function(from, to, value)
	{
		var convertBase = "0123456789abcdef";	
		var input = value.toString().toLowerCase();
		var origin = _self.NumbersType[from][2];
		var dest = _self.NumbersType[to][2];

		var b = 0; 
		var result = "";
		if (Number(origin) > convertBase.length || Number(dest) > convertBase.length || Number(origin) < 2 || Number(dest) < 2) 
			return "Invalid numbering system";
		for (var c = 1; c <= input.length; c++) 
		{ 
			b += convertBase.indexOf(input.substring(c - 1, c)) * (Math.pow(origin,input.length-c)); 
			if (convertBase.indexOf(input.substring(c - 1, c)) > Number(origin)) {
				return 'Character "'+ input.substring(c - 1, c) +'" not present in origin system'; 
			}
				
		}
		var a = Math.floor(Math.log(b)/Math.log(dest))
		while (a>-1) {
			var e = Math.pow(dest,a)
			a--;
			var d = (b-b%e)/e + 1;
			b %= e;
			carrier = convertBase.substring(d - 1, d);
			result += carrier;
		}
		return result
	}
		
}

var CUnitConvertor = function() 
{
	var ConvertorModel = new CConvertorModel();
	// Create a enum of UnitType
	function unitType()
	{
		this.Area 		= 1;
		this.Time		= 2;
		this.Weight 	= 3;
		this.Pressure 	= 4;
		this.Volume 	= 5;
		this.Temperature = 6;
		this.Distance 	= 7;
		this.Speed 		= 8;
		this.Power 		= 9;
		this.Numbers 	= 10;
	}
	
	var UnitType = new unitType;
	var _self = this;
	var _selectedUnit = UnitType.Area;
	var cmbFrom = $("cmbFrom");
	var cmbTo = $("cmbTo");
	var txtFrom = $("txtFrom");
	var txtTo = $("txtTo");
	
	/**
	 * Set event handlers for the elements 
	 * on the widget.
	 */
	function init() 
	{
		
		var click = 'onclick';
    
		$("txtFrom").onkeyup = txtFrom_KeyUp;
		$("txtFrom").onkeypress = txtFrom_KeyPress;
		$("txtFrom").onblur = txtFrom_LostFocus;
		
		$("cmbFrom").onchange = cmbFrom_Change;
		$("cmbTo").onchange = cmbTo_Change;
    
		$("radArea")[click] = radArea_Click;
		$("radTime")[click] = radTime_Click;
		$("radWeight")[click] = radWeight_Click;
		$("radPressure")[click] = radPressure_Click;
		$("radVolume")[click] = radVolume_Click;
		
		$("radTemperature")[click] = radTemperature_Click;
		$("radDistance")[click] = radDistance_Click;
		$("radSpeed")[click] = radSpeed_Click;
		$("radPower")[click] = radPower_Click;
		$("radNumbers")[click] = radNumbers_Click;

		
		// By default select decimal input
		_self.validateField = validateDecimal;
		radArea_Click(); 
	}
	

	function calculateUnits()	
	{	

		if(txtFrom.value == "" || txtFrom.value == "0" || txtFrom.value == "." || txtFrom.value == "0.") return;
		var _from = parseInt(cmbFrom.value);
		var _to = parseInt(cmbTo.value);
		
		var _value = parseComma(txtFrom.value);
		
		switch(_selectedUnit)
		{
			case UnitType.Area:	
				txtTo.value = ConvertorModel.Area(_from , _to, _value);
				break;
				
			case UnitType.Temperature:
				txtTo.value = ConvertorModel.Temperature(_from , _to, _value);
				break;
			
			case UnitType.Time:
				txtTo.value = ConvertorModel.Time(_from , _to, _value);
				break;
				
			case UnitType.Distance:			
				txtTo.value = ConvertorModel.Distance(_from , _to, _value);
				break;
				
			case UnitType.Weight:			
				txtTo.value = ConvertorModel.Weight(_from , _to, _value);
				break;	
				
			case UnitType.Speed:
				txtTo.value = ConvertorModel.Speed(_from , _to, _value);
				break;
			
			case UnitType.Pressure:			
				txtTo.value = ConvertorModel.Pressure(_from , _to, _value);
				break;
			
			case UnitType.Power:
				txtTo.value = ConvertorModel.Power(_from , _to, _value);
				break;
			
			case UnitType.Volume:
				txtTo.value = ConvertorModel.Volume(_from , _to, _value);
				break;
			
			case UnitType.Numbers:				
				txtTo.value = ConvertorModel.Numbers(_from , _to, _value);				
				break;
			
			default:
				break;
		}
	}
	
	
	function radDistance_Click(event)
	{
		_selectedUnit = UnitType.Distance;
		fillCombos(ConvertorModel.DistanceType);
		setActiveUnit("radDistance");
	}
	
	function radPower_Click(event)
	{
		_selectedUnit = UnitType.Power;
		fillCombos(ConvertorModel.PowerType);
		setActiveUnit("radPower");
	}
	
	function radSpeed_Click(event)
	{
		_selectedUnit = UnitType.Speed;
		fillCombos(ConvertorModel.SpeedType);
		setActiveUnit("radSpeed");
	}
	
	function radTime_Click(event)
	{
		_selectedUnit = UnitType.Time;
		fillCombos(ConvertorModel.TimeType);
		setActiveUnit("radTime");		
	}
	
	
	function radNumbers_Click(event)
	{
		_selectedUnit = UnitType.Numbers;
		fillCombos(ConvertorModel.NumbersType);
		setActiveUnit("radNumbers");
	}
	
	function radPressure_Click(event)
	{
		_selectedUnit = UnitType.Pressure;
		fillCombos(ConvertorModel.PressureType);	
		setActiveUnit("radPressure");
	}
	
	function radVelocity_Click(event)
	{
		_selectedUnit = UnitType.Velocity;
		fillCombos(ConvertorModel.VelocityType);
		setActiveUnit("radVelocity");
	}
	
	function radVolume_Click(event)
	{
		_selectedUnit = UnitType.Volume;
		fillCombos(ConvertorModel.VolumeType);
		setActiveUnit("radVolume");
	}
	
	function radWeight_Click(event)
	{
		_selectedUnit = UnitType.Weight;
		fillCombos(ConvertorModel.WeightType);
		setActiveUnit("radWeight");
	}
	
	function radTemperature_Click(event)
	{
		_selectedUnit = UnitType.Temperature;
		fillCombos(ConvertorModel.TemperatureType);
		setActiveUnit("radTemperature");
	}
	
	function radArea_Click(event)
	{
		_selectedUnit = UnitType.Area;
		fillCombos(ConvertorModel.AreaType);
		setActiveUnit("radArea");
	}
	
	this.validateField = function (field, event)
	{
		return true;		
	}
	
	function validateBinary(field, event)
	{
		return new RegExp(/^[0-1]+?$/i).test(field.value + String.fromCharCode(event.which));
	}
	
	function validateDecimal(field, event)
	{
		return new RegExp(/^[0-9]*?\.?[0-9]*?$/).test(field.value + String.fromCharCode(event.which));
	}
	
	function validateTemperature(field, event)
	{
		if(field.selectionStart == 0) return new RegExp(/^-?[0-9]*?\.?[0-9]*?$/).test(String.fromCharCode(event.which) + field.value);
		return new RegExp(/^-?[0-9]*?\.?[0-9]*?$/).test(field.value + String.fromCharCode(event.which));
	}
	
	function validateHex(field, event)
	{
		return new RegExp(/^[0-9a-f]+?$/i).test(field.value + String.fromCharCode(event.which));
	}
	
	function validateOcta(field, event)
	{
		return new RegExp(/^[0-8]+?$/i).test(field.value + String.fromCharCode(event.which));
	}
	
	function txtFrom_LostFocus(event)
	{
		calculateUnits();
	}
	
	function txtFrom_KeyUp(event)
	{
		if(this.value == "" || this.value == "0" || this.value == "." || this.value == "0.") 
		{
			txtTo.value = "";
			return;
		}
		calculateUnits();
	}
	
	function txtFrom_KeyPress(event)	
	{
		if(event.which == 13) this.blur();
		if(!_self.validateField(this, event)) return false;
	}
	
	function checkValidations()
	{
		switch(_selectedUnit)
		{
			case UnitType.Numbers:
				switch(parseInt(cmbFrom.value)) 
				{
					case 1:
						_self.validateField = validateBinary;						
						break;
					case 2:
						_self.validateField = validateOcta;
						break;
					case 3:
						_self.validateField = validateHex;
						break;				
					default:
						_self.validateField = validateDecimal;
						break;
				}
				txtFrom.value = "";
				txtTo.value = "";
				break;
			case UnitType.Temperature:
				_self.validateField = validateTemperature;
				break;
								
			default:
				_self.validateField = validateDecimal;
				break;
		}
		
		calculateUnits();
	}
	
	function cmbFrom_Change(event)
	{
		checkValidations();
	}
	
	function cmbTo_Change(event)
	{
		calculateUnits();
	}
			
	function setActiveUnit(id)
	{
		txtFrom.value = "";
		txtTo.value = "";
		
		var span = document.getElementsByTagName("span");
		for(var x = 0; x < span.length; x++) 
		{
			span[x].style.backgroundPosition = (span[x].id == id) ? '0 100%' : '0 0';
			span[x].style.color = (span[x].id == id) ? 'black' : 'white';
		}
		
		checkValidations();
	}
	
    var fillCombosTimeout = 0;
	function fillCombos(arrOptions)
	{
        if (fillCombosTimeout)
        {
            clearTimeout(fillCombosTimeout);
        }
        fillCombosTimeout = setTimeout(function()
        {
            fillCombosTimeout = 0;
            fillCombos2(arrOptions);
            cmbFrom.style.visibility = '';
            cmbTo  .style.visibility = '';
            log("REFLOW:" + opera.reflowCount);
        },200);
    }
    function fillCombos2(arrOptions)
    {
		var _cmbFrom = document.createElement("select");
		var _cmbTo = document.createElement("select");
		
		_cmbFrom.id = "cmbFrom";
		_cmbTo.id = "cmbTo";
		
		for(var x = 0; x < arrOptions.length; x++)
		{
			_cmbFrom.options[_cmbFrom.options.length] = new Option(arrOptions[x][1], arrOptions[x][0]);
			_cmbTo.options[_cmbTo.options.length] = new Option(arrOptions[x][1], arrOptions[x][0]);

			if(arrOptions[x][3] == 2) _cmbTo.options[_cmbTo.options.length - 1].selected = true;
			if(arrOptions[x][3] == 1) _cmbFrom.options[_cmbTo.options.length - 1].selected = true;
		}
		
		cmbFrom.parentElement.replaceChild(_cmbFrom, cmbFrom);
		cmbTo.parentElement.replaceChild(_cmbTo, cmbTo);
		
		cmbFrom = _cmbFrom;
		cmbTo = _cmbTo;
		
		cmbFrom.onchange = cmbFrom_Change;
		cmbTo.onchange = cmbTo_Change;
        
	}
    

	function parseComma(value)
	{
		value = value.replace(",", ".");
		return value;
	}	
	
	init();
		
}

window.onload = function()
{
	var UnitConvertor = new CUnitConvertor();	
}