var C_CURRENCY_MAXCHARS = 13; // max characters of a currency-name
var C_INPUT_MAXCHARS = 11;

if (!window.widget) { window.widget = {} };
if (!window.widget.preferenceForKey) { window.widget.preferenceForKey = function() { return "" }}
if (!window.widget.setPreferenceForKey) { window.widget.setPreferenceForKey = function() { return "" }}

var g_xmlString = '<?xml version="1.0" ?><exchangerates timestamp="123123123"><rate iso="NOK" name="Norwegian krone" rate="8.58974" timestamp="1190678400000"/><rate iso="USD" name="U.S. dollar" rate="1.55223" timestamp="1190678400000"/><rate iso="GBP" name="U.K. pound sterling" rate="0.772058" timestamp="1190678400000"/><rate iso="EUR" name="euro" rate="1.1004" timestamp="1190678400000"/><rate iso="SEK" name="Swedish krona" rate="10.136" timestamp="1190678400000"/><rate iso="DKK" name="Danish krone" rate="8.20472" timestamp="1190678400000"/></exchangerates>';
var g_xmlUrl = "http://oxzone.opera.com/currencies/currencies.xml";
var g_ratesDate = 0;
var g_rates = {};
var g_destructiveInput = false; // if true then the next key-press will clear g_values[0]

var g_config = {
    isArchos : (navigator.appVersion && navigator.appVersion.match(/ARCHOS/))
}
var g_values = ["",""]; // both values

function fetchRates() {
    var conn = new XMLHttpRequest();
    conn.open("GET", g_xmlUrl);
    conn.onreadystatechange = function() {
        if (this.readyState == 4 && this.status==200 ) {
            g_rates = parseCurrencyData(this.responseXML);
            g_xmlString = this.responseText;
            widget.setPreferenceForKey(g_xmlString, "xmlString");
            populateDropDowns(g_rates);
            setMessage();
        }
    }
    conn.send(null);
}

function parseCurrencyData(xml) {
    var retval = {};
    var rates = xml.getElementsByTagName("rate");
    g_ratesDate = (+xml.documentElement.getAttribute("timestamp"))  ;

    for (var n=0, r; r=rates[n]; n++) {
        var cur = {
            iso: r.getAttribute("iso"),
            name: r.getAttribute("name"),
            rate: r.getAttribute("rate")
        }
        retval[cur.iso] = cur;
    }
    return retval;
}

function populateDropDowns(ratesdict) {
    var keys = [];
    var name = "";
    for (key in ratesdict) { keys.push(key) };
    
    var sorter = function(a,b) {
        if (a>b) { return 1 }
        else if (a<b) { return -1 }
        else { return 0 }
    }
    
    keys = keys.sort(sorter);
    for (var n=0, e; e=keys[n]; n++) {
        if (e=="EUR") {
            keys.splice(n, 1);
            keys.splice(0, 0, e);
        } else if (e=="USD" && keys.length>1) {
            keys.splice(n, 1);
            keys.splice(1, 0, e);
        }
    }
    
    var curFrom = widget.preferenceForKey('cur-from') || 'EUR';
    var curTo = widget.preferenceForKey('cur-to') || 'USD';
    
    toList = document.getElementById("select_right");
    fromList = document.getElementById("select_left");
    
    while (toList.firstChild) { toList.removeChild(toList.firstChild) }
    while (fromList.firstChild) { fromList.removeChild(fromList.firstChild) }
    
    for (var n=0, e; e=keys[n]; n++) {
        name = ratesdict[e].name;
        if (name.length > C_CURRENCY_MAXCHARS)
        {
          name = name.substr(0, C_CURRENCY_MAXCHARS);
        }
        fromList.options[n] = new Option(ratesdict[e].iso + " - " + name, ratesdict[e].rate, e==curFrom, e==curFrom);
        toList  .options[n] = new Option(ratesdict[e].iso + " - " + name, ratesdict[e].rate, e==curTo, e==curTo);
        fromList.options[n].iso = e;
        toList  .options[n].iso = e;
    }
}

function recalculate(src, dst, rate1, rate2) {
    if (g_values[0] == "" && g_values[1] == "") {
        setMessage();
    }
    else
    {
        var newVal = ((parseFloat(g_values[src])||0) * val(rate2) / val(rate1) ).toFixed(2)  || "";
        g_values[dst] = newVal;
    }
    
    displayValue(0, g_values[0] || "0" );
    displayValue(1,  g_values[1] || "0" );
}
function displayValue(n, value)
{
    var ul = document.getElementsByTagName('ul')[n];
    var li = ul.getElementsByTagName('li');
    var c = 0; //character spot
    var str = ""+value;
    
    if (str.indexOf('.')>=0 && str.length-1 > C_INPUT_MAXCHARS)
    {
        str = str.substr(0,str.indexOf('.'));
    }
    if (str.length + (str.indexOf('.')>=0 ? -1 : 0) > C_INPUT_MAXCHARS)
    {
      str = ""; // showing nothing is better than false values
    }
  
    var offs = {
        9: -1*33,
        8: -2*33,
        7: -3*33,
        6: -4*33,
        5: -5*33,
        4: -6*33,
        3: -7*33,
        2: -8*33,
        1: -9*33,
        0: -10*33
    }
    
    var c = str.length;
    for (var i = li.length-1; i>=0; i--)
    {
        c--;
        if (str[c]=='.') // skip the point
        {
            c--;
        }
        li[i].style.backgroundPosition = (n==0 ? '0 ' : '100% ') + (offs[str[c]] || 0)+'px';
    }

    // set decimal
    c = str.indexOf('.');
    ul.style.backgroundPosition = c<0 ? '-4px 0' : (23*(li.length-str.length+c+1)-1)+'px ' + (n== 0 ? '30px' : '-24px');
}

//* changing left value recalcs right value.
//* changing right value recalcs left value.
//* changing left currency recalcs left value.
//* changing right currency relcalcs right value.
function setMessage(msg) {
    var e = document.getElementById("currencyDate");
    if (msg) { e.textContent = msg}
    else {
        var t = new Date().getTime();
        var days = Math.floor((t - g_ratesDate) / (60*1000*60*24));
        var str = "Exchange rates are ";
        
        if (days==0) {
            str += "from today";
        } else if (days==1) {
            str += "from one day ago";
        } else if (days<14) {
            str += "from " + days + " days ago";
        } else {
            str += "old! (more than 2 weeks)";
        }
        if (e.textContent !=  str)
        {
            e.textContent = str;
        }
    }
}

function swapValues()
{
    // swap drop downs
    var ele1 = document.getElementById('select_left');
    var ele2 = document.getElementById('select_right');
    var ind1 = ele1.options.selectedIndex;
    var ind2 = ele2.options.selectedIndex;
    ele1.options.selectedIndex = ind2;
    ele2.options.selectedIndex = ind1;
    
    // swap right-value
    g_values[0] = g_values[1];
    
    g_destructiveInput = true;
    
    recalculate(0, 1, "select_left", "select_right");
}

function changeCurrency(evt)
{
    widget.setPreferenceForKey(this.options[this.options.selectedIndex].iso, (this.id == 'select_left' ?  'cur-from' : 'cur-to') );
    recalculate(0, 1, "select_left", "select_right");
    g_destructiveInput = true;
}

function changeValue() {
    recalculate(0, 1, "select_left", "select_right");
}

function clearInputs() {
    g_destructiveInput = false;
    g_values[0] = "";
    g_values[1] = "";
    recalculate(0, 1, "select_left", "select_right");
}

function backSpace() {
    g_destructiveInput = false;
    if (g_values[0].length) {
        g_values[0] = g_values[0].slice(0, -1);
        changeValue();
    }
}

function val(e) {
    if (typeof e == "number") { return parseFloat(e)}
    var ele = document.getElementById(e);
    if(ele.nodeName.toLowerCase() == "select" || ele.nodeName.toLowerCase() == "input") {
        return parseFloat(ele.value);
    } else {
        return parseFloat(ele.textContent);
    }
}

function inputNumber(n) {
    
    if (g_destructiveInput)
    {
        g_values[0] = "";
        g_destructiveInput = false;
    }
    
    opera.postError(g_values[0].replace(/\./,'').length);
    // repsect maxlength
    if (
       g_values[0].replace(/\./,'').length>=C_INPUT_MAXCHARS ||
       g_values[1].substr(0,(g_values[1].indexOf('.')+1||g_values[1].length+1)-1).length>=C_INPUT_MAXCHARS
    )
    { return; }
    
    // both these if's make sure we don't get like 0005 etc.
    if (n==0 && (!g_values[0] || g_values[0]=="0"))
    {
      return;
    }
    if (n!=0 && g_values[0]=="0")
    {
      g_values[0] = "";
    }
    
    g_values[0] += n;
    changeValue();
}

function inputComma() {
    if (g_destructiveInput)
    {
        g_values[0] = "";
        g_destructiveInput = false;
    }
    if (!g_values[0])
    {
        g_values[0] = "0.";
        changeValue();
    }
    else if (g_values[0].indexOf(".")==-1) {
        g_values[0] += ".";
        changeValue();
    }
}
function init() {
    if (widget.preferenceForKey("xmlString") || g_xmlString) {
        var parser=new DOMParser();
        var doc=parser.parseFromString((widget.preferenceForKey("xmlString")||g_xmlString),"text/xml");
        g_rates = parseCurrencyData(doc);
        populateDropDowns(g_rates);
    }

    var selects = document.getElementsByTagName("select");
    selects[0].addEventListener("change", changeCurrency, false )
    selects[1].addEventListener("change", changeCurrency, false )

    document.getElementById('buttonbar').addEventListener('click', function(e)
    {        
        if (e.target.tagName.toLowerCase() != 'button') { return; }
        
        var value = e.target.value;
        
        switch (value)
        {
            case "." : inputComma(); break;
            case "backspace" : backSpace(); break;
            case "clear" : clearInputs(); break;
            case "swap" : swapValues(); break;
            default : inputNumber(parseInt(value)); break;
        }
    }, false);

    setMessage();
    recalculate();
    fetchRates();
}

window.onload = init;