
var g_config = {
    isArchos : (navigator.appVersion && navigator.appVersion.match(/ARCHOS/))
};


function $(ele) { return document.getElementById(ele); }
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/, ''); };

window.addEventListener("load", function(){
	
	var vaults = new Vaults();	
	
}, false);


var Vaults = function(){

	var g_current_li = null;			// stores reference of the currently expanded li 
	var g_allVaults = new Array();
	var g_master_hash = null;
	var g_master = null;
	var g_prefix = null;
	var g_timer = null;
	var scroller = null;
	
	// Vault object
	var Vault = function(desc, date){
		this.desc = desc || '';
		this.date = date || '';
	}

	function init(){
	
		/*
		 *  Event handlers for the elements
		 */ 
		
		$('btCreatePwd').addEventListener('click', btCreatePwd_click , false);
		$('btLogin').addEventListener('click', btLogin_click, false);
		$('btLogout').addEventListener('click', function(){
			g_current_li = null;
			setLoggedIn(null);
			document.onkeypress = null;
		}, false);
		
		$('btAddNew').addEventListener('click', showAddNew, false);
		
		$('btSave').addEventListener('click', closeView, false);
		$('btCancel').addEventListener('click', cancelVault, false);
		
		$('btEdit').addEventListener('click', function() { showAddNew(true) }, false);
		$('btDel').addEventListener('click', delVault, false);
		$('btClose').addEventListener('click', closeVault, false);

		$('desc').addEventListener('blur', function(){ enableSave(); }, false);
		
		$('txtCreatePwd').onkeyup = enterHandler(btCreatePwd_click);
		$('txtLogin').onkeyup = enterHandler(btLogin_click);
		
		$('msgCreatePwd').addEventListener('click', msgCreatePwd_click, false);
		$('txtCreatePwd').addEventListener('blur', txtCreatePwd_blur, false);
		
		$('btReset').addEventListener('click', btReset_click , false);
		
		loadData();
		setLoggedIn(null);
		
	}
	
	function enterHandler(func) {
		return function(e) {
			if ( e.keyCode == 13 ) func(e);
		};
	}
	
	function msgCreatePwd_click(){
		this.style.display = 'none';
		$('txtCreatePwd').focus();
	}
	
	function txtCreatePwd_blur(e){
		if( '' == e.target.value ){
			$('msgCreatePwd').style.display = 'block';		
		}
	}
	
	function loadData() {
		var master_hash = null;
		var vaults = null;
		var prefix = null;
	
		master_hash = widget.preferenceForKey( 'master_hash' );
		vaults = widget.preferenceForKey( 'vaults' );
		prefix = widget.preferenceForKey( 'prefix' );

		if ( ! prefix ) {
			prefix = p_random();
			widget.setPreferenceForKey( prefix, 'prefix' );
		}
	
		g_master_hash = master_hash;
		g_prefix = prefix;
	
		try{
			if ( vaults ) {
				g_allVaults = vaults.parseJSON();
			}
		}catch(e) { log("parse error..."); }
	}

	function btCreatePwd_click(){
		
		var el_out = $('spCreatePwd');
		var el_in = $('txtCreatePwd');
		var pass = el_in.value;
		var hash = hex_sha1( pass );
		
		el_in.value = '';
		
		if ( pass.length < 1 ) {
			el_out.innerText = 'The master password must be at least 1 character long.';
			return;
		}
		
		g_master_hash = hash;
		setHash();
		
		setLoggedIn( pass );
		
	}
	
	function btLogin_click(){
		var el_out = $('spLogin');
		var el_in = $('txtLogin');
		var pass = el_in.value;
		var hash = hex_sha1( pass );

		if ( hash != g_master_hash ) {
		
			$('spReset').innerText = 'Start all over by deleting current password and data.';
			$('btYes').style.display = 'none';
			$('btNo').style.display = 'none';
			$('btReset').style.display = 'block';
			$("divReset").style.visibility = "visible";
			
			el_out.innerHTML = "Incorrect password!";
			el_out.style.fontSize = "26";
			return;
			
		}
		
		el_in.value = '';
		el_out.innerText = 'Please enter the master password to login.';
		el_out.style.fontSize = "16";
		setLoggedIn( pass );
		
	}
	
	function setHash(hash) {
		widget.setPreferenceForKey( g_master_hash, 'master_hash' );
	}
	
	function p_encrypt(str) {
		return tea_ofb( str, g_master, true );
	}
	function p_decrypt(str) {
		return tea_ofb( str, g_master, false );
	}
	function p_random() {
		return word_hex( [ uint32_random() ] );
	}

	function setLoggedIn(pass) {
		var logged_in = pass ? true : false;
	
		if ( logged_in ) {
			g_master = g_prefix + pass;
			$('loginView').style.display = 'none';
			showDataView();
			
			$('txtCreatePwd').onkeyup = null;
			$('txtLogin').onkeyup = null;
		}
		else {
			g_master = null;
			showLoginView();
			
			$('txtCreatePwd').onkeyup = enterHandler(btCreatePwd_click);
			$('txtLogin').onkeyup = enterHandler(btLogin_click);
		}
	}
	
	function showLoginView() {
		$('dataView').style.display = 'none';
		$('btLogout').style.display = 'none';
		$("divReset").style.visibility = "hidden";
		
		$('loginView').style.display = 'block';
		$('divLogin').style.display = g_master_hash ? 'block' : 'none';
		$('divCreatePwd').style.display = !g_master_hash ? 'block' : 'none';
		
		if(g_master_hash )
			$('txtLogin').focus();

	}
	
	function showDataView(){
		
		$('dataView').style.display = 'block';
		$('btLogout').style.display = 'block';
		
		$('addMode').style.display = 'none';
		$('viewMode').style.display = 'none';
		$('list').style.display = 'block';
		
		scroller = new Scroller();
		scroller.scrollDiv();
		
		document.onkeypress = scroller.vaultKeypress;
	}
	
	function showAddNew(bEdit) {
	
		var desc = '';
		
		if(true == bEdit){
			
			desc = p_decrypt ( g_allVaults[ g_current_li.posInList ].desc );
			$('viewMode').style.display = 'none';
		}

		$('list').style.display = 'none';
		$('addMode').style.display = 'block';
				
		$('btSave').disabled = true;
		
		$('desc').value = desc;
		$('desc').focus();
		
		document.onkeypress = null;
	}
	
	function viewVault(){
		
		$('list').style.display = 'none';
		$('viewMode').style.display = 'block';
		
		g_current_li = this;
		
		$('vaultData').innerText = p_decrypt( g_allVaults[ this.posInList ].desc );
		$('spDate').innerText = g_allVaults[ this.posInList ].date;
	
		document.onkeypress = null;
	}
	
	function closeView() {
		
		var dt = new Date().getDate() + "." + (new Date().getMonth() + 1) + "." + (new Date().getFullYear()); 
		var bAddMode = false;
		
		if (g_current_li){
			var ta = document.createElement('textarea');
			ta.value = p_decrypt(g_allVaults[g_current_li.posInList].desc) ;
		 	if ( ta.value != $('desc').value){
				// update array
				var enc = '';
				try{
					enc = p_encrypt ( $('desc').value );
				}catch(e){ 
					log("problem with encryption...");
					return; 
				}
				g_allVaults[g_current_li.posInList].desc = enc; 
				g_allVaults[g_current_li.posInList].date = dt;
			
				// udpate item in the list 
				g_current_li.innerText = $('desc').value.trim();
			
				saveVaults();
			}
			g_current_li = null;
			
		}
		else{
			if( '' != $('desc').value){
				// add vault to array
				
				try {
					var pass = p_encrypt( $('desc').value );
				} catch (e) {
					log("problem with encryption...");
					return;
				}

				// add item to the beginning of the array	
				g_allVaults.unshift( new Vault( pass, dt) );
				
				// add item to the list
				var span = document.createElement('span');
				span.innerText = $('desc').value.trim();
				span.onclick = viewVault;
				span.onmouseover = hoverVault;
				$('vaultsList').insertBefore( span, $('vaultsList').firstChild);
				
				saveVaults();
				resetItemPositions();
				bAddMode = true;
			}
		}
			
		document.onkeypress = scroller.vaultKeypress;
		$('addMode').style.display = 'none';
		$('list').style.display = 'block';

		if(bAddMode){
			if(-1 != scroller.getSelected())
				scroller.setSelected( scroller.getSelected() + 1);

			scroller.selectOption(0);
			
			scroller.scrollDiv();
		}		
		
	}
	
	function resetItemPositions(){
		var spans = $('vaultsList').getElementsByTagName('span');
		
		for(var i = 0; i < spans.length ; i++){
			spans[i].posInList = i;
		}
	}
	
	function cancelVault(){
		if(g_current_li){		// editing existing
			$('addMode').style.display = 'none';
			$('viewMode').style.display = 'block';
		}
		else{					// adding new one
			$('addMode').style.display = 'none';			
			$('list').style.display = 'block';
		}
		
		document.onkeypress = scroller.vaultKeypress;
	}
	
	function enableSave(){
		if( g_current_li){
			var ta = document.createElement('textarea');
			ta.value = p_decrypt(g_allVaults[g_current_li.posInList].desc) ;
			if ( ta.value != $('desc').value){
				 
				$('btSave').disabled = false;
			}
			else
				$('btSave').disabled = true;
		}
		else if ('' != $('desc').value ){
			
			$('btSave').disabled = false;
		}
		else
			$('btSave').disabled = true;		
	}
	
	function saveVaults(){
		widget.setPreferenceForKey(g_allVaults.toJSONString(), 'vaults');
	}

	function delVault(){
		
		if(g_current_li){
			
			// remove vault from the array
			g_allVaults.splice( g_current_li.posInList, 1);
			
			// remove vault from the list
			$('vaultsList').removeChild(g_current_li);
			
			// remove vault from preferences
			saveVaults();
			
			g_current_li = null;
		
			resetItemPositions();
			
		}
		
		$('viewMode').style.display = 'none';
		$('list').style.display = 'block';
		
		scroller.scrollDiv();
		document.onkeypress = scroller.vaultKeypress;
	}
	
	function closeVault(){
		g_current_li = null;
		$('viewMode').style.display = 'none';
		$('list').style.display = 'block';
		document.onkeypress = scroller.vaultKeypress;
	}
	
	function hoverVault(e){
	  scroller.selectOption(e.target.posInList);
	}
	 
    function Scroller()
    {
        var self = this;
        var up   = $('scrollUp');
        var down = $('scrollDown');
        var div = $('vaultsList');
        var spans = div.getElementsByTagName('span');

        var moveDirection = 0; // will be 1 or -1
                
        var interval = 0; // setInterval holder
                
        function populateList(list)
        {
            var frag = document.createDocumentFragment();
            var span = null;
            
            for (var i=0; i<list.length; i++)
            {
                span = document.createElement('span');
                span.innerText = p_decrypt(list[i].desc).trim();
                span.onclick = viewVault;
                span.onmouseover = hoverVault;
                span.posInList = i;
                frag.appendChild(span);
            }
            div.innerHTML = ''; 
            div.appendChild(frag);
        }
        populateList(g_allVaults);
        
        var selected = -1;
        this.selectOption = function(sel)
        {
            var ele = spans[selected];
            if (ele )//&& ele.className)
            {
                //ele.className = ''
				ele.style.backgroundPosition = "0 0";
				ele.style.color = '#C4C1B8';
            };
            
            selected = sel;
            
            if (selected < 0            ) { selected = 0;              }
            if (selected >= spans.length) { selected = spans.length-1; }
			
			if(spans.length == 0 ) return;
			
            ele = spans[selected];
            
//            spans[selected].className = 'selected';
			ele.style.backgroundPosition = "0 100%";
			spans[selected].style.color = 'black';
  
            var max = (ele.offsetTop + 40) -ele.offsetHeight;
            var min = (ele.offsetTop + 40 ) -div.offsetHeight;
            
            if (div.scrollTop < min)
            {
                div.scrollTop = min;
            }
            if (div.scrollTop > max)
            {
                div.scrollTop = max;
            }
        }
        
        this.vaultKeypress = this.keypress = function(e)
        {
            var ele = spans[selected];
            
            switch (e.keyCode)
            {
                case 38: // up
                    self.selectOption(selected-1);
                    break;
                
                case 40: // down
                    self.selectOption(selected+1);
                    break;
                
                case 13: // enter
                    if (selected<0 && spans.length==1)
                    {
                        selected = 0;
                    }
                    if (spans[selected])
                    {
                        spans[selected].onclick();
                    }
                    break;
                default: return;
            }
            e.preventDefault();
        }
        
        this.scrollDiv = div.onscroll = function(e)
        {
            var min = 0;
            var max = div.scrollHeight - div.offsetHeight;
            
            up.disabled   = (div.scrollTop <= min);
            down.disabled = (div.scrollTop >= max);
        };
        
//        var evtStr = (g_config.isArchos ? 'onmouseover' : 'onclick');
        
        up.onclick = function()
        {
            self.selectOption(selected-1);
        };
        down.onclick = function()
        {
            self.selectOption(selected+1);
        };
        
		this.getSelected = function() { return selected; };
		this.setSelected = function(val) { selected = val; };
    }
	
	function btReset_click(){

		$('spReset').innerText = 'Confim to delete your password and data.';
		$('btReset').style.display = 'none';
		$('btYes').style.display = 'block';
		$('btNo').style.display = 'block';
		
		var callback = function(flag){
			
			if(flag)		// yes
				resetData();

			$("divReset").style.visibility = "hidden";
		}
		
		$("btYes").onclick = function(){ callback(true); };
		$("btNo").onclick = function(){ callback(false); };
	}
	
	function resetData(){
		widget.setPreferenceForKey( '', 'prefix' );
		widget.setPreferenceForKey( '', 'master_hash' );
		widget.setPreferenceForKey( '', 'vaults' );

		g_allVaults = [];	
	
		var el_out = $('spLogin');

		$('txtLogin').value = '';
		el_out.style.fontSize = "16";
		el_out.innerText = 'Please enter the master password to login.';
	
		loadData();
		setLoggedIn(null);
	}
	
	function log(msg){
//		opera.postError(msg);
	}
	
	init();
	
}