function g(e){return document.getElementById(e);}

var C_DAYSOFWEEK = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];

var C_WIND_TEXT = ['No wind', 'Light air', 'Light breeze', 'Gentle breeze', 'Moderate breeze', 'Fresh breeze', 'Strong breeze', 'Near gale', 'Gale', 'Severe gale', 'Storm', 'Violent storm', 'Hurricane'];

var C_TODAY_TEXT = ['Today', 'Afternoon', 'Evening', 'Tonight'];

var C_CACHE_LENGTH = 10;
var C_RESULTS_LENGTH = 50;

var C_SEARCH_URL = 'http://oxine.opera.com/~runeh/weather/weather.php?term=';
var C_DATA_URL = 'http://oxine.opera.com/~runeh/weather/weather_dev.php'; // ?location=

var g_config = {
    isArchos : (navigator.appVersion && navigator.appVersion.match(/ARCHOS/))
};

var g_errors = {
    NO_NET: 'No network available<br>Try exiting the widget and enabling an internet connection.',
    NO_SERVER: 'The server is experiencing problems. Please try again later.',
    NO_RESULTS: 'Cannot access server'
}

function getBeaufortWind(speed)
{
    var n = -1;
    if (speed < 1000) n = 12;
    if (speed < 120) n = 11;
    if (speed < 103) n = 10;
    if (speed < 88) n = 9;
    if (speed < 76) n = 8;
    if (speed < 63) n = 7;
    if (speed < 51) n = 6;
    if (speed < 40) n = 5;
    if (speed < 30) n = 4;
    if (speed < 20) n = 3;
    if (speed < 12) n = 2;
    if (speed <  7) n = 1;
    if (speed <  1) n = 0;
    return n==-1 ? '' : C_WIND_TEXT[n];    
}

function getWeatherImage(symbol, day)
{
    var str = day ? 'd' : 'n';
    
    return 'img/' + ({
        1: '01'+str,
        2: '02'+str,
        3: '03'+str,
        4: '04',
        5: '05'+str,
        6: '06'+str,
        7: '07'+str,
        8: '08'+str,
        9: '09',
       10: '10',
       11: '11',
       12: '12',
       13: '13',
       14: '14',
       15: '15',
       16: '16',
       17: '17',
       18: '18',
       19: '19'
    }[symbol] || '00') + '.png';
}

/*
    Request a file with url and callback
    Callback gets the xml or null
    Returns an abortion function
*/
function getXML(url, callback)
{
    opera.postError(url);
    var xhr = null;
    
    var timeout = setTimeout(function()
    {
        if (xhr && xhr.abort)
        {
            timeout = 0;
            xhr.abort();
            callback(null);
        }
    }, 60*1000); // 60 second max timer
    
    try {
        xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function()
        {
            if (timeout && this.readyState == 4) {
                
                clearTimeout(timeout);
                timeout = 0;
                callback( this.status ? this.responseXML : null); // any status indicates a server response
            }
        }
        xhr.open('GET',url,true);
        xhr.send();
    }
    catch (e)
    {
        clearTimeout(timeout);
        timeout = 0;
        // avoid synchronous callback
        setTimeout(function()
        {
            callback(null);
        },1);
    }
    
    return function() // returns an abort function
    {
        if (timeout && xhr && xhr.abort)
        {
            clearTimeout(timeout);
            timeout = 0;
            xhr.abort();
            return true;
        }
        return false;
    };
}


var weather = new function()
{
    var self = this;
    var pref = {
        fahrenheit: !!widget.preferenceForKey('fahrenheit')
    };
    
    function savePref()
    {
        widget.setPreferenceForKey(pref.fahrenheit ? '1' : '', 'fahrenheit');
    }
    
    var days = null; // array of forecast data
    
    document.addEventListener('load', init, false);
    
    function init()
    {
        scroller = new Scroller();
        
        var showFull = false;
        g('button-location').onclick = function()
        {
            var selection = g('selection');
            var forecast = g('forecast');
            
            showFull = !showFull;
            
            forecast.style.display = showFull ? 'block' : '';
            selection.style.display = showFull ? 'none' : '';
        };
        
        g('button-unit').onclick = function()
        {
            pref.fahrenheit = !pref.fahrenheit;
            this.className = pref.fahrenheit ? 'fahrenheit' : '';
            savePref();
            updateResults();
        }
        
        if (pref.fahrenheit)
        {
            g('button-unit').className = 'fahrenheit';
        }
        
        cityHistory.show(true);
    }

    var cityHistory = new function()
    {
        this.history = [];
        
        // constant, length of history
        var C_LENGTH = 7;
        
        // load history from storage
        var name = "";
        var id = "";
        var i=0;
        
        for (; i<C_LENGTH; i++)
        {
            name = widget.preferenceForKey('cityName'+i);
            id = widget.preferenceForKey('cityId'+i);
            
            if (name && id)
            {
                this.history[i] = {name: name, id: id};
            }
            else { break; }
        }
        
        this.add = function(name, id)
        {
            var i=0;
            var j=0;
            
            // add entry to start of array
            this.history.unshift({name:name,id:id});
            
            // remove duplicate entries
            for (i=0; i+1<this.history.length; i++)
            {
                for (j=this.history.length-1; j>i; j--)
                {
                    if (this.history[i].id==this.history[j].id)
                    {
                        this.history.splice(j,1); // remove second entry
                        j--;
                    }
                }
            }
            
            // limit length of array
            if (this.history.length > C_LENGTH)
            {
                this.history.length = C_LENGTH;
            }
            
            // save array
            for (i=0; i<C_LENGTH; i++)
            {
                name = this.history[i] && this.history[i].name;
                id = this.history[i] && this.history[i].id;
                
                widget.setPreferenceForKey(name || '','cityName'+i);
                widget.setPreferenceForKey(id || '','cityId'+i);
            }
        }
        this.show = function(preload)
        {
            var ele = g('selection-history');
            var str = "";
            var arr = this.history;
            
            var defaultCities = !arr.length;
            
            ele.getElementsByTagName('span')[0].innerText =  defaultCities ? 'Or choose a popular city:' : 'Previous cities:';
            
            if (defaultCities)
            {
                arr = [
                    {id:1816670,name:"Beijing, China"},
                    {id:993800, name:"Johannesburg, South Africa"},
                    {id:2643743,name:"London, United Kingdom"},
                    {id:5128581,name:"New York City, United States"},
                    {id:2147714,name:"Sydney, Australia"},
                    {id:3871336,name:"Santiago, Chile"},
                    {id:1850147,name:"Tokyo, Japan"}
                ];
            }
            
            for (var i=0; i<arr.length; i++)
            {
                str += '<li>'+arr[i].name+'</li>';
            }
            ele.getElementsByTagName('ol')[0].innerHTML = str;
            var li = ele.getElementsByTagName('li');
            for (i=0; i<li.length; i++)
            {
                li[i].location_id = arr[i].id;
                li[i].onclick = clickCity;
            }
            if (preload)
            {
                if (defaultCities || !li[0])
                {
                    getDefaultCity();                    
                }
                else
                {
                  li[0].onclick.apply(li[0], null);
                }
            }
        }
    }
    
    function getDefaultCity()
    {
        document.getElementById('cityTitle').innerText = '';
        var url = C_DATA_URL;
        
        getXML(url, callback);
        
        function callback(responseXML)
        {
            var results = parseFeed(responseXML);
            if (results)
            {
                displayResults(results);
            }
            else
            {
                showNetworkError(responseXML ? getDefaultCity : null);
            }
            
        }
    }
    
    function getLocalePrecipitationString(str, symbol)
    {
        var n = parseFloat(str);
        var type = (symbol == 8 || symbol == 13 || symbol == 19) ? 'snow' : (symbol == 7 || symbol == 12) ? 'rain/show' : 'rain';
        if (isNaN(n))
        {
            return '';
        }
        if (pref.fahrenheit)
        {
            n = (Math.round((n/25.4)*10)/10);
            return n ? (n+' in of '+type) : '';
        }
        return n ? (n+' mm of '+type) : '';
    }
    
    function getLocaleSpeedString(str) // str in ms
    {
        var n = parseFloat(str);
        if (isNaN(n))
        {
            return '?';
        }
        if (pref.fahrenheit)
        {
            return (Math.round((n/0.3048)*10)/10) + 'ft/s';
        }
        return str = n+' m/s';
    }
    
    function getLocaleTemperatureString(str) // str in degrees C
    {
        var n = parseFloat(str);
        if (isNaN(n))
        {
            str = '?';
        }
        else
        {
            if (pref.fahrenheit)
            {
                n = Math.round(n*9/5+32); // conversion to 0 decimal places
            }
            str = n+''; // fix to 1 decimal place and stringify
        }
        return str+'&deg;'+(pref.fahrenheit ? 'F' : 'C');
    }
    
    function showNetworkError(retryFunction)
    {
        var ele = g('selection-fail');
        
        if (retryFunction)
        {
            ele.innerHTML = '<img src="img/nonet.png"><span>'+g_errors.NO_SERVER+'</span>';
            var button = document.createElement('button');
            button.innerText = 'Retry';
            ele.appendChild(button);
            button.onclick = button.onmousedown = function()
            {
                ele.style.display = 'none';
                retryFunction();
            }
        }
        else
        {
            ele.innerHTML = '<img src="img/nonet.png"><span>'+g_errors.NO_NET+'</span>';
        }
        ele.style.display = 'block';
        document.getElementById('cityTitle').innerText = '';
    }
    
    var clickCity_abort = null; // holds a function (currying)
    
    function clickCity(e)
    {
        var self = this;
        
        var city = this.innerText;
        var id = this.location_id;
        
        g('selection-loading').style.display = 'block';
        g('button-location').style.display = 'none';
        g('selection-fail').style.display = '';
        g('today-data').style.display = 'none';
        
        if (clickCity_abort)
        {
            clickCity_abort();
        }
        
        scroller.selectOption(this.posInList);
        
        function callback(responseXML)
        {
            clickCity_abort = null;
            g('selection-loading').style.display = '';
            
            var results = parseFeed(responseXML);
            if (results)
            {
                displayResults(results);
                g('button-location').style.display = '';
                g('today-data').style.display = '';
                g('selection').style.display = 'none';
                g('forecast').style.display = 'block';
                g('search').value = '';
                g('search').className = 'empty';
                g('selection-scroll').style.display = '';
                g('selection-history').style.display = '';
                cityHistory.add(city, id);
                cityHistory.show();
            }
            else
            {
                showNetworkError(responseXML ?  function() { clickCity.apply(self, null); } : null);
            }
        }
        
        g('cityTitle').innerText = city;
        
        // make sure it takes longer than a second, good for feeling good :)
        var d = new Date();
        function callback2(xml)
        {
            var passed = (new Date()).getTime() - d.getTime();
            if (passed > 0 && passed < 1000)
            {
                setTimeout(function(){callback(xml);}, 1000-passed);
            }
            else
            {
                callback(xml);
            }
        }
        
        var url = C_DATA_URL + '?location=' + encodeURIComponent(id);
        
        // return value of getFeed is a function to abort the xhr
        clickCity_abort = getXML(url, callback2);
    }

    
    var scroller = null; // will be an instance of Scroller() soon
    function Scroller()
    {
        var self = this;
        var scroll = g('selection-scroll');
        var history = g('selection-history');
        var up   = g('scroll-up');
        var down = g('scroll-down');
        var div = scroll.getElementsByTagName('div')[0];
        var spans = div.getElementsByTagName('span');
        
        var moveDirection = 0; // will be 1 or -1
        
        var interval = 0; // setInterval holder
                
        function populateList(list)
        {
            // these variables are to help us remember which item was last selected
            var selected_id = "";
            var selectedEle = null; // element
            var selectedNum = 0;
            if (spans[selected])
            {
                selected_id = spans[selected].location_id;
            }
            
            if (!list) // show previous cities
            {
                history.style.display = '';
                scroll.style.display = ''; // none
                div.innerHTML = ''; // sabotage
                return;
            }
            
            scroll.style.display = 'block';
            history.style.display = 'none';
            
            // network error
            if (list == -1)
            {
                div.innerHTML = '<p>'+g_errors.NO_RESULTS+'.</p>';
                up.disabled = down.disabled = true;
                return;
            }
            
            var frag = document.createDocumentFragment();
            var span = null;
            
            for (var i=0; i<list.length; i++)
            {
                span = document.createElement('span');
                span.innerText = list[i].name;
                span.location_id = list[i].id;
                span.onclick = clickCity;
                span.onmouseover = hoverCity;
                span.posInList = i;
                frag.appendChild(span);
                if (selected_id && list[i].id==selected_id)
                {
                    selected_id = "";
                    selectedNum = i;
                    selectedEle = span;
                }
            }
            if (i==0) // no results
            {
                div.innerHTML = '<p>No results.</p>';
                up.disabled = down.disabled = true;
                return;
            }
            
            div.innerHTML = ''; // sabotage
            div.appendChild(frag);
            if (selectedEle)
            {
                self.selectOption(selectedNum);
            }
            else
            {
                self.selectOption(null);
            }
        }
        
        function hoverCity(e)
        {
           self.selectOption(e.target.posInList);
        }
        
        var selected = -1;
        this.selectOption = function(sel)
        {
            
            var ele = spans[selected];
            if (ele && ele.className)
            {
                ele.className = ''
            };
            
            if (sel==null)
            {
                selected = -1;
            }
            else
            {
                selected = sel;
                if ( selected < 0) { selected = 0; }
                if ( selected > spans.length-1) { selected = spans.length-1; }
            }
            
            up.disabled   = (selected < 1);
            down.disabled = (selected == spans.length-1);
            
            ele = spans[selected];
            
            if (!ele) { return; }
            
            spans[selected].className = 'selected';
            
            // not sure why these constants are needed, but without them
            // the list does not scroll to the correct position,
            // probably a function of heights and padding / borders etc.
            var max = ele.offsetTop-ele.offsetHeight-7;
            var min = ele.offsetTop-div.offsetHeight-5;
            
            if (div.scrollTop < min)
            {
                div.scrollTop = min;
            }
            if (div.scrollTop > max)
            {
                div.scrollTop = max;
            }
            
        }
        
        var search = g('search');
        
        search.onfocus = function()
        {
            if (this.className == 'empty')
            {
                this.className = '';
            }
        };
        search.onblur = function()
        {
            if ( !this.value.replace(/\s+/g,''))
            {
                this.value = '';
                this.className = 'empty';
            }
            this.oninput();
        };
        search.oninput = function()
        {
            if ( this.value.replace(/[\__\s_\._,_\+_\-_\(_\)_\\_\/]+/g,'') )
            {
                requestList(this.value);
            }
            else
            {
                populateList(null);
            }
        }
        
        var requestList = (function() // curry
        {
            var spin = g('search-spin');
            var xhrAbort = null;
            
            var resultsCache = []; // we will cache queries to improve speed
            
            /*
             An example of a cache-entry:
                {
                   search: "sy",
                   hasMore: false,
                   results: [ "Sydney, Australia" , "Allepo, Syria" ]
                }
            */
            
            var searchString = "";
            
            function receiveResults(xml)
            {
                xhrAbort = null;
                
                var str = searchString;
                var arr = null; // results
                var hasMore = false;
                
                if (xml)
                {
                    arr = [];
                    try
                    {
                        var place = xml.
                                    getElementsByTagName('places')[0].
                                    getElementsByTagName('place');
                        
                        for (var i=0; i<place.length; i++)
                        {
                            if (i==C_RESULTS_LENGTH)
                            {
                                hasMore = true;
                                break;
                            }
                            arr[i] = {
                              name: place[i].getAttribute('name')+', '+place[i].getAttribute('country'),
                              searchnames: place[i].getAttribute('searchnames'),
                              id: place[i].getAttribute('id')
                            }
                        }
                    }
                    catch (e)
                    {
                        arr = null;
                    }
                }
                    
                
                spin.style.visibility = '';

                // store the results, ensure cache isn't too big
                resultsCache.push( { search:str, hasMore: hasMore, results: arr } );
                if (resultsCache.length > C_CACHE_LENGTH)
                {
                    resultsCache.shift();
                }
                
                populateList(arr || -1);
            }
            
            return function(str)
            {
                str = str.toLowerCase();
                
                if (str == searchString){return;}
                
                searchString = str;
                
                // cancel previeous request
                if (xhrAbort) {
                    xhrAbort();
                }
                
                var arr = null; // the possible cached search results
                
                // this for-loop looks for cached search-results
                // that we can use instead of requesting from the server
                
                for (var i=0; i<resultsCache.length; i++)
                {
                    
                    // if we have searched this exact string before
                    if (resultsCache[i].search == str)
                    {
                        arr = resultsCache[i].results;
                    }
                    else
                    {
                        // if we can narrow down an existing search result ourself
                        if (!resultsCache[i].hasMore && str.search(resultsCache[i].search))
                        {
                            if (resultsCache[i].results)
                            {
                                // make copy of results
                                arr = resultsCache[i].results.concat();
                                
                                // filter that copy
                                for (i=arr.length-1; i>=0; i--)
                                {
                                    if (!arr[i].searchnames.search(str))
                                    {
                                        arr.splice(i,1); // remove from results
                                    }
                                }
                            }
                        }
                    }
                    
                    if (arr) // yes we have cache
                    {
                        spin.style.visibility = ''; // hide animator
                        populateList(arr);
                        return;
                    }
                }
                
                // show loading
                spin.style.visibility = 'visible';
                
                var url = C_SEARCH_URL + encodeURIComponent(str);
                
                xhrAbort = getXML(url, receiveResults);

            }
            
        })();
        
        
        document.onkeypress = this.keypress = function(e)
        {
            var ele = spans[selected];
            
            switch (e.keyCode)
            {
                case 38: // up
                    self.selectOption(selected-1);
                    break;
                
                case 40: // down
                    self.selectOption(selected+1);
                    break;
                
                case 13: // enter
                    if (selected<0 && spans.length==1)
                    {
                        selected = 0;
                    }
                    if (spans[selected])
                    {
                        spans[selected].onclick();
                    }
                    break;
                default: return;
            }
            e.preventDefault();
        }
        
        if (0) div.addEventListener('mousedown', function(e1)
        {
            var startTop = div.scrollTop;
            var mousemove = function(e2)
            {
                var newTop = startTop + (e1.clientY-e2.clientY);
                div.scrollTop = Math.max(Math.min(newTop, div.scrollHeight - div.offsetHeight), 0);
                e2.preventDefault();
                e2.stopPropagation();
            };
            var mouseup = function()
            {
                document.removeEventListener('mousemove',mousemove,false);
                document.removeEventListener('mouseup',  mouseup,  false);
            };
            document.addEventListener('mousemove',mousemove,false);
            document.addEventListener('mouseup',  mouseup,  false);
            e1.preventDefault();
        }, false);
        
        var evtStr = (g_config.isArchos ? 'onmouseover' : 'onclick');
        
        up[evtStr] = function()
        {
            self.selectOption(selected-1);
        };
        down[evtStr] = function()
        {
            self.selectOption(selected+1);
        };
        
    }
    
    // takes the bare xml file and returns an array of objects
    function parseFeed(xml)
    {
        var days = null; // xml node-list
        var results = []; // an array of result objects
        var i = 0;
        
        try {
            
            var days = xml.getElementsByTagName('forecasts')[0].getElementsByTagName('day');
           
            for (i=0; i<3; i++)
            {
                results[i] = {};
                results[i].date          =             days[i].getAttribute('date').toDate();
                results[i].windspeed     = parseFloat( days[i].getAttribute('windspeed'));
                results[i].winddirection = parseFloat( days[i].getAttribute('winddirection'));
                results[i].symbol        = parseInt(   days[i].getAttribute('symbol'));
                results[i].maxtemp       = parseFloat( days[i].getAttribute('maxtemp'));
                results[i].mintemp       = parseFloat( days[i].getAttribute('mintemp'));
                
                results[i].precipitation = parseFloat(days[i].getAttribute('precipitation'));
            }
            results.title = xml.getElementsByTagName('forecasts')[0].getAttribute('location');
        }
        catch (e)
        {
            return null;
        }
        
        return results;
    }
    
    function updateResults()
    {
        if (!days){return;}
        
        var ele_days = [g('today'),g('tomorrow'),g('thedayafter')];
        
        for (var i=0; i<3; i++)
        {
            ele_days[i].getElementsByClassName('temperature')[0].innerHTML = getLocaleTemperatureString(days[i].maxtemp) + '<span>'+getLocaleTemperatureString(days[i].mintemp)+'</span>';
        }
        
        var rainString = getLocalePrecipitationString(days[0].precipitation, days[0].symbol);
        
        g('rain').style.display = rainString ? '' : 'none';
        g('rain').innerHTML = rainString;
        
    }
    
    var arrowImg = new Image(); arrowImg.src = 'img/arrow.png';
    
    function drawWind(dir, speed)
    {
        // arrow dimensions
        var stemWidth = 1.5;
        var headWidth = 6;
        var headDist = 10; // dist from center to start of head
        
        var canvas = g('wind-direction');
        var ctx = canvas.getContext('2d');
        
        ctx.clearRect(0,0,40,40);
        
        if (isNaN(dir))
        {
            return; // leave the canvas empty
        }
        
        // prepare canvas
        ctx.save();
        ctx.translate(20,20);
        ctx.rotate((1+dir/180)*Math.PI);
        ctx.fillStyle = '#ffffff';
        ctx.strokeStyle = '#fff';
        ctx.lineWidth = 1.5;
        
        /*
         To work out the number of feathers to put on the arrow
         we must convert to knots.
         For every 50 knots we put a triangle on.
         for every 10 knots we put a big feather on.
         If there is 5 knots left we put a half feather on.
        */
        
        // convert from km/h to knots
        speed = speed / 1.852;        
        
        // tool for keeping track of drawing position
        var offset = 15;
        
        // draw triangles, indicators of 50 knots
        while (speed >= 50 && offset>2)
        {
            ctx.beginPath();
            ctx.moveTo(-1.5,offset);
            ctx.lineTo(-9,offset-2.25);
            ctx.lineTo(-1.5,offset-4.5);
            ctx.closePath();
            ctx.fill();
            
            offset -= 5.5;
            speed -= 50;
        }
        // dont bother showing anything over 150 knots
        if (speed < 50)
        {
            // draw long feathers, indicators of 10 knots
            while (speed >= 10 && offset>-5)
            {
                ctx.beginPath();
                ctx.moveTo(0,offset);
                ctx.lineTo(-11,offset);
                ctx.lineTo(-11,offset-1.5);
                ctx.lineTo(0,offset-1.5);
                ctx.closePath();
                ctx.fill();
                
                offset -= 3.5;
                speed -= 10;
            }
            
            // draw short feathers, indicators of 5 knots
            if (speed >= 5 && offset>-4)
            {
                
                ctx.beginPath();
                ctx.moveTo(0,offset);
                ctx.lineTo(-7,offset);
                ctx.lineTo(-7,offset-1.5);
                ctx.lineTo(0,offset-1.5);
                ctx.closePath();
                ctx.fill();
            }
        }
        
        // draw the arrow
        ctx.beginPath();
        ctx.moveTo(-stemWidth,15);
        ctx.lineTo(+stemWidth,15);
        ctx.lineTo(+stemWidth,-headDist);
        ctx.lineTo(+headWidth,-headDist);
        ctx.lineTo(0,-20);
        ctx.lineTo(-headWidth,-headDist);
        ctx.lineTo(-stemWidth,-headDist);
        ctx.closePath();
        ctx.fill();
        
        // back to reality
        ctx.restore();
    }
    
    function displayResults(results)
    {
        days = results; // store in the larger global scope
        
        var ele_days = [g('today'),g('tomorrow'),g('thedayafter')];
        var ele = null;
        
        var todaystring = "";
        
        var timedifference = results[0].date.getHours() - results[1].date.getHours();
        // we can calculate what the 'todaystring' should be
        // based on the difference between the hours of today's forecast and tomorrow's
        // because we know tomorrow's is set to mid-day
        
        var daytime = true; // day
        
        if (timedifference > 2) todaystring = C_TODAY_TEXT[1]; // This afternoon;
        if (timedifference > 5) todaystring = C_TODAY_TEXT[2]; // This evening;
        if (timedifference > 8) {
            todaystring = C_TODAY_TEXT[3]; // Tonight;
            daytime = false;
        }
        
        if (!todaystring) todaystring = C_TODAY_TEXT[0];
        
        
        for (var i=0; i<3; i++)
        {
            ele = ele_days[i].getElementsByClassName('symbol')[0];
                ele.src = getWeatherImage(days[i].symbol, daytime);
                ele.style.display = 'block';
            ele_days[i].getElementsByClassName('day')[0].innerText = i==0 ? todaystring : C_DAYSOFWEEK[days[i].date.getDay()];
            daytime = true; // for the second and third iteration it will be daytime
        }
        
        var title = results.title;
        if (title)
        {
            document.getElementById('cityTitle').innerText = title;
        }
        
        var windText = getBeaufortWind(days[0].windspeed);
        
        if (windText == C_WIND_TEXT[0])
        {
          g('wind-direction').style.display = 'none';
        }
        else
        {
          g('wind-direction').style.display = '';
          drawWind(days[0].winddirection, days[0].windspeed);
        }
        g('wind').innerText = windText;
        
        
        
        updateResults()
    }
    
    
    
};