String.prototype.toHTML = function()
{
    return this.replace(/\&/,'&amp;').replace(/\</,'&lt;').replace(/\>/,'&gt;');
}

String.prototype.search = function(str)
{
    
    var self = this.toLowerCase();
    var queries = str.toLowerCase().split(/[\__\s_\._,_\+_\-_\(_\)_\\_\/]+/g);
    
    // nothing left after split
    if (queries.length==0 || queries.length==1 && !queries[0])
    {
        return false;
    }
    
    for (var i=0; i<queries.length; i++)
    {
        // check if the entry has a value (the first and last may not)
        if (queries[i] && self.indexOf(queries[i])<0)
        {
            return false;
        }
    }
    
    // everything found
    return true;
}

if (!Element.prototype.getElementsByClassName)
{
    Element.prototype.getElementsByClassName = function(className)
    {
      if (!className || className.match(/\s/)) throw Error("Invalid className");
      
      var arr    = [];
      var ele    = this.getElementsByTagName('*');
      var i      = ele.length;
      var regexp = new RegExp('\\b'+className+'\\b');
      
      while (i-->0)
      {
        if (regexp.test(ele[i].className))
        {
          arr[arr.length] = ele[i];
        }
      }
      return arr;
    }
}

/** 
 * Converts a "sloppy formatted" string to a Date.
 * @returns The string converted to a date
 * @type Date
 **/

String.prototype.toDate = function(){
  var year,month,day,h,m,s=0, ms=0,tz="Z", sign;
  var tzOffset = new Date().getTimezoneOffset();
  var datestring = this.split(/T|\ /);
  if (datestring[0].length == 8) {
    // upcoming.org's broken format
    year = datestring[0].substring(0,4);
    month = datestring[0].substring(4,6);
    day = datestring[0].substring(6,8);
  } else if (datestring[0].length == 10){
    var t = datestring[0].split("-");
    year = t[0];
    month = t[1];
    day = t[2];
  }
  if (datestring.length > 1){ 
    var timestring = datestring[1].split(/\+|-|Z/);
    var a_time = timestring[0].split(":");
    h = a_time[0];
    m = a_time[1];
    if (a_time.length > 2)
    {
      s = a_time[2]
      if (a_time.length > 3)
      {
        ms = a_time[3];
      }
    }
     // Get timezone 
    if ((timestring.length > 1) && timestring[1].length){
      if (timestring[1].length == 3){
        sign = datestring[1].slice(datestring[1].length-4,datestring[1].length-3);
        tz = 60*timestring[1].substring(0,1);
        tz = tz+timestring[1].slice(-2);
      } else if (timestring[1].length == 4){
        sign = datestring[1].slice(datestring[1].length-5,datestring[1].length-4);
        tz = 60*parseInt(timestring[1].slice(0,2));
        tz = tz+parseInt(timestring[1].slice(-2));
      } else if (timestring[1].length == 5){
        sign = datestring[1].slice(datestring[1].length-6,datestring[1].length-5);
        tz = 60*parseInt(timestring[1].slice(0,2));
        tz = tz+parseInt(timestring[1].slice(-2));
      } 
    } else {
      tz = 0; //tzOffset;
    }
  }
  
  var ret = new Date();
  ret.setUTCFullYear(year);
  ret.setUTCMonth(month-1);
  ret.setUTCDate(day);
  ret.setUTCHours(h);
  ret.setUTCMinutes(m-tz);
  ret.setUTCSeconds(s);
  ret.setUTCMilliseconds(ms);
  
  return ret;
}