
var g_config = {
    isArchos : (navigator.appVersion && navigator.appVersion.match(/ARCHOS/))
};

function $(ele) { return document.getElementById(ele); }

window.addEventListener("load", function(){
	
	var notes = new Notes();	
	
}, false);

String.prototype.trim = function() { return this.replace(/^\s+|\s+$/, ''); };

var Notes = function(){

	var g_current_li = null;			// stores reference of the currently expanded li 
	var g_allNotes = new Array();
	var g_timer = null;
	var scroller = null; 
	
	// Note object
	var Note = function(desc, date){
		this.desc = desc || '';
		this.date = date || '';
	}
	
	function init(){
	
		/* 
		 *  Event handlers for the elements
		 */ 
		
		$('btAddNew').addEventListener('click', showAddNew, false);
		
		$('btSave').addEventListener('click', closeView, false);
		$('btCancel').addEventListener('click', cancelNote, false);
		
		$('btEdit').addEventListener('click', function() { showAddNew(true) }, false);
		$('btDel').addEventListener('click', delNote, false);
		$('btClose').addEventListener('click', closeNote, false);
		
		$('desc').addEventListener('blur', function(){ enableSave(); }, false);
		$('desc').addEventListener('keyup', function(){ enableSave(); }, false);
		
		loadData();
		
		document.onkeypress = scroller.noteKeypress;

	}
	
	function loadData(){
		
		var notes = widget.preferenceForKey('notes');
		
		// get data from preferences
		try{
			if(notes)
				g_allNotes = notes.parseJSON();
		}catch(e) { log("parse error..."); }

		scroller = new Scroller();
		
		scroller.scrollDiv();
				
	}
	
	function showAddNew(bEdit) {
	
		var desc = '';
		
		if(true == bEdit){
			desc = g_allNotes[ g_current_li.posInList ].desc;
			$('viewMode').style.display = 'none';
		}

		$('list').style.display = 'none';
		$('addMode').style.display = 'block';
				
		$('btSave').disabled = true;
		
		$('desc').value = desc;
		$('desc').focus();
		
		document.onkeypress = null;
	}
	
	function viewNote(){
		
		$('list').style.display = 'none';
		$('viewMode').style.display = 'block';
		
		g_current_li = this;
		
		$('noteData').innerText = g_allNotes[ this.posInList ].desc;
		$('spDate').innerText = g_allNotes[ this.posInList ].date;
	
		document.onkeypress = null;
	}
	
	function cancelNote(){
		if(g_current_li){		// editing existing
			$('addMode').style.display = 'none';
			$('viewMode').style.display = 'block';
		}
		else{					// adding new one
			$('addMode').style.display = 'none';			
			$('list').style.display = 'block';
		}
		
		document.onkeypress = scroller.noteKeypress;
	}
	
	function closeNote(){
		g_current_li = null;
		$('viewMode').style.display = 'none';
		$('list').style.display = 'block';
		document.onkeypress = scroller.noteKeypress;
	}
	
	
	function closeView() {
		
		var dt = new Date().getDate() + "." + (new Date().getMonth() + 1) + "." + (new Date().getFullYear()); 
		var bAddMode = false;
		
		if (g_current_li){
		 	if (g_allNotes[g_current_li.posInList].desc != $('desc').value){
				// update array
				g_allNotes[g_current_li.posInList].desc = $('desc').value;
				g_allNotes[g_current_li.posInList].date = dt;
			
				// udpate item in the list
				g_current_li.innerText = $('desc').value.trim();
			
				saveNotes();
			}
			g_current_li = null;
		}
		else{
			if( '' != $('desc').value){
				// add note to array
				g_allNotes.unshift( new Note($('desc').value, dt) );
				
				// add item to the list
				var span = document.createElement('span');
				span.innerText = $('desc').value.trim();
				span.onclick = viewNote;
				span.onmouseover = hoverNote;
				$('notesList').insertBefore( span, $('notesList').firstChild);
				
				saveNotes();
				resetItemPositions();
				bAddMode = true;
			}
			
		}
		
		document.onkeypress = scroller.noteKeypress;
		$('addMode').style.display = 'none';
		$('list').style.display = 'block';
		
		if(bAddMode){
			if(-1 != scroller.getSelected())
				scroller.setSelected( scroller.getSelected() + 1);
				
			scroller.selectOption(0);
			
			scroller.scrollDiv();
		}
		
	}
	
	function saveNotes(){
		widget.setPreferenceForKey(g_allNotes.toJSONString(), 'notes')
	}
	
	function delNote(){
		
		if(g_current_li){
			
			// remove note from the array
			g_allNotes.splice( g_current_li.posInList, 1);
			
			// remove note from the list
			$('notesList').removeChild(g_current_li);
			
			// remove note from preferences
			saveNotes();
			
			g_current_li = null;
		
			resetItemPositions();
		}
		
		$('viewMode').style.display = 'none';
		$('list').style.display = 'block';
		
		scroller.scrollDiv();
		
		document.onkeypress = scroller.noteKeypress;		
	}
	
	function resetItemPositions(){
		var spans = $('notesList').getElementsByTagName('span');
		
		for(var i = 0; i < spans.length ; i++){
			spans[i].posInList = i;
		}
	}
	
	function enableSave(){
		if( g_current_li){
			if ( g_allNotes[g_current_li.posInList].desc != $('desc').value){				 
				$('btSave').disabled = false;
			}
			else
				$('btSave').disabled = true;
		}
		else if ('' != $('desc').value ){
			$('btSave').disabled = false;
		}
		else
			$('btSave').disabled = true;		
	}
	
	function hoverNote(e){
	  scroller.selectOption(e.target.posInList);
	}
	
    function Scroller()
    {
        var self = this;
        var up   = $('scrollUp');
        var down = $('scrollDown');
        var div = $('notesList');
        var spans = div.getElementsByTagName('span');

        var moveDirection = 0; // will be 1 or -1
                
        var interval = 0; // setInterval holder
                
        function populateList(list)
        {
            var frag = document.createDocumentFragment();
            var span = null;
            
            for (var i=0; i<list.length; i++)
            {
                span = document.createElement('span');
                span.innerText = list[i].desc.trim();
                span.onclick = viewNote;
                span.onmouseover = hoverNote;
                span.posInList = i;
                frag.appendChild(span);
            }
            div.innerHTML = ''; 
            div.appendChild(frag);
        }
        populateList(g_allNotes);
        
        var selected = -1;
        this.selectOption = function(sel)
        {
            var ele = spans[selected];
            if (ele ) //  && ele.className)
            {
//                ele.className = ''
				ele.style.backgroundPosition = "0 0";
				ele.style.color = '#C4C1B8';
            };
            
            selected = sel;
            
            if (selected < 0            ) { selected = 0;              }
            if (selected >= spans.length) { selected = spans.length-1; }

			if(spans.length == 0) return;
			
            ele = spans[selected];
            
//            spans[selected].className = 'selected';
			spans[selected].style.backgroundPosition = "0 100%";
			spans[selected].style.color = 'black';
  
            var max = (ele.offsetTop + 40) -ele.offsetHeight;
            var min = (ele.offsetTop + 40 ) -div.offsetHeight;
            
            if (div.scrollTop < min)
            {
                div.scrollTop = min;
            }
            if (div.scrollTop > max)
            {
                div.scrollTop = max;
            }
        }
        
        this.noteKeypress = this.keypress = function(e)
        {
            var ele = spans[selected];
            
            switch (e.keyCode)
            {
                case 38: // up
                    self.selectOption(selected-1);
                    break;
                
                case 40: // down
                    self.selectOption(selected+1);
                    break;
                
                case 13: // enter
                    if (selected<0 && spans.length==1)
                    {
                        selected = 0;
                    }
                    if (spans[selected])
                    {
                        spans[selected].onclick();
                    }
                    break;
                default: return;
            }
            e.preventDefault();
        }
        
        this.scrollDiv = div.onscroll = function(e)
        {
            var min = 0;
            var max = div.scrollHeight - div.offsetHeight;
            
            up.disabled   = (div.scrollTop <= min);
            down.disabled = (div.scrollTop >= max);
			
        };
      
//        var evtStr = (g_config.isArchos ? 'onmouseover' : 'onclick');
        
        up.onclick = function()
        {
            self.selectOption(selected-1);
        };
        down.onclick = function()
        {
            self.selectOption(selected+1);
        };
        
		this.getSelected = function() { return selected; };
		this.setSelected = function(val) { selected = val; };
    }
	
	function log(msg){
//		opera.postError(msg);
	}

	init();
	
}
