/*************************************************************************************************

License terms as defined in the file license.txt, which MUST be distributed unmodified with this file.

**************************************************************************************************/

/*
	Create a widget face.
	
	string faceID - the ID of the DOM container element to attach to.
*/

Face = function(faceID)
{
	var self = this;
	var elementID = faceID;
	var element = null;
	
	/* When DOM is loaded, find the container element */
	
	self.init = function()
	{
		element = document.getElementById(faceID);
	}
	
	/* No fading for faces yet - Opera on Windows doesn't handle fading translucent images well */
	
	self.close = function(fast)
	{
		if (element)
		{
			element.style.opacity = "0.0";
			element.style.display = "none";
		}
	}

	self.open = function(fast)
	{
		if (element)
		{
			element.style.opacity = "1.0";
			element.style.display = "block";
		}
	}
	
	/* Can be overridden by Face instances */
	
	self.redraw = function() { }

	
}